VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   3045
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   8850
   LinkTopic       =   "Form1"
   ScaleHeight     =   203
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   590
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command4 
      Caption         =   "Try Pause Session"
      Height          =   465
      Left            =   150
      TabIndex        =   5
      Top             =   2160
      Width           =   3450
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Try Play Session"
      Height          =   465
      Left            =   150
      TabIndex        =   4
      Top             =   1620
      Width           =   3450
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Refresh Infos"
      Height          =   465
      Left            =   150
      TabIndex        =   3
      Top             =   1080
      Width           =   3450
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Refresh Sessions"
      Height          =   465
      Left            =   150
      TabIndex        =   2
      Top             =   540
      Width           =   3450
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   150
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   120
      Width           =   3450
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   150
      Left            =   3690
      ScaleHeight     =   120
      ScaleWidth      =   120
      TabIndex        =   0
      Top             =   120
      Width           =   150
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2022

' How to use:
' Dieses Programm starten.
' Chrome und/oder FireFox starten, zu Youtube gehen und ein Video starten und gleich wieder pausieren.
' Button "Refresh Sessions" drcken.
' Nun sollten in der ComboBox aktive Sessions aufgelistet werden.
' Session auswhlen, Infos zur Session werden im Debugfenster ausgegeben.
' Die Wiedergabe der Session kann gestartet oder auch gestoppt werden.
' Ansonsten knnte man damit jedes Programm steuern und Infos auslesen, die die SystemMediaTransportControls
' https://learn.microsoft.com/en-us/uwp/api/windows.media.systemmediatransportcontrols?view=winrt-22621
' verwenden. Die SystemMediaTransportControls werden angezeigt, wenn man auf der Tastatur
' die VolumeUp/VolumeDown-Taste drckt. Einige Infos werden nur angezeigt, wenn die Session auch entsprechende
' Infos in die SystemMediaTransportControls schreibt.

Option Explicit

Private lngSessionsCount As Long
Private cGlobalSystemMediaTransportControlsSession() As clsGSMTCS
Private cGlobalSystemMediaTransportControlsSessionManager As clsGSMTCSM

Private Sub Form_Load()
    Set cGlobalSystemMediaTransportControlsSessionManager = New clsGSMTCSM
    lngSessionsCount = cGlobalSystemMediaTransportControlsSessionManager.GetSessionsCount
    Me.Caption = "SessionsCount: " & CStr(lngSessionsCount)
    If lngSessionsCount > 0& Then
        Dim lngSessionsItem As Long
        ReDim cGlobalSystemMediaTransportControlsSession(lngSessionsCount - 1)
        ReDim cGlobalSystemMediaTransportControlsSessions(lngSessionsCount - 1)
        For lngSessionsItem = 0 To lngSessionsCount - 1
            Set cGlobalSystemMediaTransportControlsSession(lngSessionsItem) = _
                cGlobalSystemMediaTransportControlsSessionManager.GetSessionByIndex(lngSessionsItem)
            Combo1.AddItem "Session" & Format$(lngSessionsItem + 1, "00") & " (" & _
                           cGlobalSystemMediaTransportControlsSession(lngSessionsItem).GetSourceAppUserModelId & ")"
        Next
        Combo1.ListIndex = 0
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If lngSessionsCount > 0& Then
        Dim lngSessionsItem As Long
        For lngSessionsItem = 0 To lngSessionsCount - 1
            Set cGlobalSystemMediaTransportControlsSession(lngSessionsItem) = Nothing
        Next
    End If
    Set cGlobalSystemMediaTransportControlsSessionManager = Nothing
End Sub

Private Sub Combo1_Click()
    Call RefreshInfos(Combo1.ListIndex)
End Sub

Private Sub Command1_Click()
    Call LoadNew
End Sub

Private Sub Command2_Click()
    Call RefreshInfos(Combo1.ListIndex)
End Sub

Private Sub Command3_Click()
    If lngSessionsCount > 0& Then
        Debug.Print "TryPlay: " & cGlobalSystemMediaTransportControlsSession(Combo1.ListIndex).TryPlay
    End If
End Sub

Private Sub Command4_Click()
    If lngSessionsCount > 0& Then
        Debug.Print "TryPause: " & cGlobalSystemMediaTransportControlsSession(Combo1.ListIndex).TryPause
    End If
End Sub

Private Sub LoadNew()
    Dim lngSessionsItem As Long
    Combo1.Clear
    If lngSessionsCount > 0& Then
        For lngSessionsItem = 0 To lngSessionsCount - 1
            Set cGlobalSystemMediaTransportControlsSession(lngSessionsItem) = Nothing
        Next
    End If
    Set cGlobalSystemMediaTransportControlsSessionManager = Nothing

    Set cGlobalSystemMediaTransportControlsSessionManager = New clsGSMTCSM
    lngSessionsCount = cGlobalSystemMediaTransportControlsSessionManager.GetSessionsCount
    Me.Caption = "SessionsCount: " & CStr(lngSessionsCount)
    If lngSessionsCount > 0& Then
        ReDim cGlobalSystemMediaTransportControlsSession(lngSessionsCount - 1)
        For lngSessionsItem = 0 To lngSessionsCount - 1
            Set cGlobalSystemMediaTransportControlsSession(lngSessionsItem) = _
                cGlobalSystemMediaTransportControlsSessionManager.GetSessionByIndex(lngSessionsItem)
            Combo1.AddItem "Session" & Format$(lngSessionsItem + 1, "00") & " (" & _
                           cGlobalSystemMediaTransportControlsSession(lngSessionsItem).GetSourceAppUserModelId & ")"
        Next
        Combo1.ListIndex = 0
    End If
End Sub

Private Sub RefreshInfos(ByVal Index As Long)

    If lngSessionsCount > 0& Then
    
        Debug.Print "SourceAppUserModelId: " & cGlobalSystemMediaTransportControlsSession(Index).GetSourceAppUserModelId

        Dim cGlobalSystemMediaTransportControlsSessionMediaProperties As clsGSMTCSMP
        Set cGlobalSystemMediaTransportControlsSessionMediaProperties = cGlobalSystemMediaTransportControlsSession(Index).TryGetMediaProperties
        If Not cGlobalSystemMediaTransportControlsSessionMediaProperties Is Nothing Then
            Debug.Print "Title: " & cGlobalSystemMediaTransportControlsSessionMediaProperties.GetTitle
            Debug.Print "Subtitle: " & cGlobalSystemMediaTransportControlsSessionMediaProperties.GetSubtitle
            Debug.Print "AlbumArtist: " & cGlobalSystemMediaTransportControlsSessionMediaProperties.GetAlbumArtist
            Debug.Print "Artist: " & cGlobalSystemMediaTransportControlsSessionMediaProperties.GetArtist
            Debug.Print "AlbumTitle: " & cGlobalSystemMediaTransportControlsSessionMediaProperties.GetAlbumTitle
            Debug.Print "TrackNumber: " & CStr(cGlobalSystemMediaTransportControlsSessionMediaProperties.GetTrackNumber)
            Debug.Print "AlbumTrackCount: " & CStr(cGlobalSystemMediaTransportControlsSessionMediaProperties.GetAlbumTrackCount)
            Debug.Print "PlaybackType: " & cGlobalSystemMediaTransportControlsSessionMediaProperties.GetPlaybackTypeAsString
            Dim lngGenresCount As Long
            lngGenresCount = cGlobalSystemMediaTransportControlsSessionMediaProperties.GetGenresCount
            Debug.Print "GenresCount: " & lngGenresCount
            If lngGenresCount > 0& Then
                Dim strGenres As String
                Dim lngGenresItem As Long
                For lngGenresItem = 0 To lngGenresCount - 1
                    strGenres = strGenres & cGlobalSystemMediaTransportControlsSessionMediaProperties.GetGenreByIndex(lngGenresItem) & ", "
                Next
                Debug.Print "Genre: " & strGenres
            End If
            Picture1.Picture = cGlobalSystemMediaTransportControlsSessionMediaProperties.GetThumbnail
            Picture1.Width = Me.ScaleX(Picture1.Picture.Width, vbHimetric, vbPixels)
            Picture1.Height = Me.ScaleY(Picture1.Picture.Height, vbHimetric, vbPixels)
            Debug.Print "ThumbnailSize: " & Me.ScaleX(Picture1.Picture.Width, vbHimetric, vbPixels) & " x " & Me.ScaleY(Picture1.Picture.Height, vbHimetric, vbPixels)
            Set cGlobalSystemMediaTransportControlsSessionMediaProperties = Nothing
        End If
    
        
        Dim cGlobalSystemMediaTransportControlsSessionTimelineProperties As clsGSMTCSTP
        Set cGlobalSystemMediaTransportControlsSessionTimelineProperties = cGlobalSystemMediaTransportControlsSession(Index).GetTimelineProperties
        If Not cGlobalSystemMediaTransportControlsSessionTimelineProperties Is Nothing Then
            Debug.Print "StartTime: " & cGlobalSystemMediaTransportControlsSessionTimelineProperties.GetStartTime
            Debug.Print "EndTime: " & cGlobalSystemMediaTransportControlsSessionTimelineProperties.GetEndTime
            Debug.Print "MinSeekTime: " & cGlobalSystemMediaTransportControlsSessionTimelineProperties.GetMinSeekTime
            Debug.Print "MaxSeekTime: " & cGlobalSystemMediaTransportControlsSessionTimelineProperties.GetMaxSeekTime
            Debug.Print "Position: " & cGlobalSystemMediaTransportControlsSessionTimelineProperties.GetPosition
            Debug.Print "LastUpdatedTime: " & cGlobalSystemMediaTransportControlsSessionTimelineProperties.GetLastUpdatedTime
            Set cGlobalSystemMediaTransportControlsSessionTimelineProperties = Nothing
        End If
    
        
        Dim cGlobalSystemMediaTransportControlsSessionPlaybackInfo As clsGSMTCSPI
        Set cGlobalSystemMediaTransportControlsSessionPlaybackInfo = cGlobalSystemMediaTransportControlsSession(Index).GetPlaybackInfo
        If Not cGlobalSystemMediaTransportControlsSessionPlaybackInfo Is Nothing Then
            Debug.Print "PlaybackStatus: " & cGlobalSystemMediaTransportControlsSessionPlaybackInfo.GetPlaybackStatusAsString
            Debug.Print "PlaybackType: " & cGlobalSystemMediaTransportControlsSessionPlaybackInfo.GetPlaybackTypeAsString
            Debug.Print "AutoRepeatMode: " & cGlobalSystemMediaTransportControlsSessionPlaybackInfo.GetAutoRepeatModeAsString
            Debug.Print "PlaybackRate: " & cGlobalSystemMediaTransportControlsSessionPlaybackInfo.GetPlaybackRate
            Debug.Print "IsShuffleActive: " & cGlobalSystemMediaTransportControlsSessionPlaybackInfo.GetIsShuffleActive
            
            Dim cGlobalSystemMediaTransportControlsSessionPlaybackControls As clsGSMTCSPC
            Set cGlobalSystemMediaTransportControlsSessionPlaybackControls = cGlobalSystemMediaTransportControlsSessionPlaybackInfo.GetControls
            If Not cGlobalSystemMediaTransportControlsSessionPlaybackControls Is Nothing Then
                Debug.Print "IsPlayEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsPlayEnabled
                Debug.Print "IsPauseEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsPauseEnabled
                Debug.Print "IsStopEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsStopEnabled
                Debug.Print "IsRecordEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsRecordEnabled
                Debug.Print "IsFastForwardEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsFastForwardEnabled
                Debug.Print "IsRewindEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsRewindEnabled
                Debug.Print "IsNextEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsNextEnabled
                Debug.Print "IsPreviousEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsPreviousEnabled
                Debug.Print "IsChannelUpEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsChannelUpEnabled
                Debug.Print "IsChannelDownEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsChannelDownEnabled
                Debug.Print "IsPlayPauseToggleEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsPlayPauseToggleEnabled
                Debug.Print "IsShuffleEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsShuffleEnabled
                Debug.Print "IsRepeatEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsRepeatEnabled
                Debug.Print "IsPlaybackRateEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsPlaybackRateEnabled
                Debug.Print "IsPlaybackPositionEnabled: " & cGlobalSystemMediaTransportControlsSessionPlaybackControls.GetIsPlaybackPositionEnabled
                Set cGlobalSystemMediaTransportControlsSessionPlaybackControls = Nothing
            End If
            Set cGlobalSystemMediaTransportControlsSessionPlaybackInfo = Nothing
        End If
    
    End If

End Sub
